/*
 * Copyright (C) 2008 Luke Kenneth Casson Leighton <lkcl@lkcl.net>
 * Copyright (C) 2008 Alp Toker <alp@atoker.com>
 * Copyright (C) 2008 Apple Inc.
 */
#ifndef __GdomMouseEvent_H__
#define __GdomMouseEvent_H__
#include <webkit/webkitdefines.h>
#include "gdom/GdomDOMWindow.h"
#include "gdom/GdomEventTargetNode.h"
#include "gdom/GdomUIEvent.h"
#include "glib-object.h"


G_BEGIN_DECLS

typedef struct _GdomMouseEvent GdomMouseEvent;
typedef struct _GdomMouseEventClass GdomMouseEventClass;


#define GDOM_TYPE_MOUSE_EVENT            (gdom_mouse_event_get_type())
#define GDOM_MOUSE_EVENT(obj)            (G_TYPE_CHECK_INSTANCE_CAST((obj), GDOM_TYPE_MOUSE_EVENT, GdomMouseEvent))
#define GDOM_MOUSE_EVENT_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST((klass),  GDOM_TYPE_MOUSE_EVENT, GdomMouseEvent)Class)
#define GDOM_IS_MOUSE_EVENT(obj)         (G_TYPE_CHECK_INSTANCE_TYPE((obj), GDOM_TYPE_MOUSE_EVENT))
#define GDOM_IS_MOUSE_EVENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((klass),  GDOM_TYPE_MOUSE_EVENT))
#define GDOM_MOUSE_EVENT_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS((obj),  GDOM_TYPE_MOUSE_EVENT, GdomMouseEventClass))

typedef struct _GdomMouseEventPrivate GdomMouseEventPrivate;

struct _GdomMouseEvent {
    GdomUIEvent parent_instance;
    GdomMouseEventPrivate *priv;
};

struct _GdomMouseEventClass {
    GObjectClass parent_class;
};

WEBKIT_API GType
gdom_mouse_event_get_type (void);

WEBKIT_API void
gdom_mouse_event_init_mouse_event (GdomMouseEvent *thiz, gchar * type, gboolean can_bubble, gboolean cancelable, GdomDOMWindow * view, glong detail, glong screen_x, glong screen_y, glong client_x, glong client_y, gboolean ctrl_key, gboolean alt_key, gboolean shift_key, gboolean meta_key, gushort button, GdomEventTargetNode * related_target);

G_END_DECLS

#endif /* __GdomMouseEvent_H__ */
